/* control.h
Header file for control.c

Copyright (C) 2006-2007 by Malte Marwedel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  US
*/

#ifndef control_H
 #define control_H


#define CONTROL_MAX_ERRORNUMS 4

#define MAIN_MENU_ENTRIES 7

/*Do not change (the numbers depend of the according index in the main_menu
  array AND the 'the_menu' array ): */
#define C_M_HEAD 0
#define C_M_CHARGE 1
#define C_M_DISCHARGE 2
#define C_M_DISANDCHARGE 3
#define C_M_MEASURE 4
#define C_M_CONSTANT 5
#define C_M_INFO 6

struct value_selector {
PGM_VOID_P firstline;
u16 min;
u16 max;
u08 returnidx;
};

#define C_NUM_MENUPARTS 31

struct menu_selector {
const u08 next;
const u08 prev;
const struct value_selector * val_sel;
u08 (*execute) (struct menu_selector * the_menu);
};

struct daytime {
u08 seconds;
u08 minutes;
u08 hours;
};

extern u16 maxout_voltage;	//in mV

void control_thread(void);

#endif
